/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef DEBUGEVENT_20070116_H_
#define DEBUGEVENT_20070116_H_

#include "Types.h"
#include "DebugEventBase.h"
#include <QString>
#include <QPair>
#include "API.h"

class EDB_EXPORT DebugEvent : public DebugEventBase {
public:
	DEBUG_EVENT event;

	DebugEvent();
	DebugEvent(DEBUG_EVENT &e);
	DebugEvent(const DebugEvent &other);
	DebugEvent &operator=(const DebugEvent &rhs);
	virtual ~DebugEvent() {}

	int exitCode() const;
	int signalCode() const;
	int stopCode() const;
	REASON reason() const;
	edb::tid_t thread() const;
	edb::pid_t process() const;
	
	bool exited() const;
	bool signaled() const;
	bool stopped() const;

	TRAP_REASON trapReason() const;
	
	// stops
	static const int sigtrap	= 1;
	static const int sigkill	= -1;
	static const int sigalrm	= -2;
	static const int sigstop	= -3;
	
	bool isError() const;
	Message errorDescription() const;
};

#endif

