/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

Copyright (C) 2009 Arvin Schnell
                   aschnell@suse.de

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/


#ifndef QY2NODE_20090903_H_
#define QY2NODE_20090903_H_

#include <QGraphicsPathItem>
#include <QPicture>
#include <graphviz/gvc.h>

class GraphWidget;

class QY2Node : public QGraphicsPathItem {
public:
	QY2Node(const GraphWidget *graph, node_t *node);

public:
    enum { Type = UserType + 2 };

    int type() const {
        // Enable the use of qgraphicsitem_cast with this item.
        return Type;
    }

public:
	virtual void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);

private:
    QPainterPath makeShape(node_t *node) const;
    void makePolygonHelper(node_t *node, QPainterPath &path) const;
	void makeEllipseHelper(node_t *node, QPainterPath &path) const;
	void drawLabel(const textlabel_t *textlabel);

public:
	QString name;
	
private:
	QPicture			picture;
	const GraphWidget	*graph;
};

#endif
