/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "MemRegion.h"
#include "MemoryRegions.h"

//------------------------------------------------------------------------------
// Name: ~MemRegion()
// Desc: 
//------------------------------------------------------------------------------
MemRegion::~MemRegion() {	
}


//------------------------------------------------------------------------------
// Name: setPermissions(bool read, bool write, bool execute)
// Desc: wrapper around normal set permissions
//------------------------------------------------------------------------------
void MemRegion::setPermissions(bool read, bool write, bool execute) {
	Q_UNUSED(read);
	Q_UNUSED(write);
	Q_UNUSED(execute);
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
bool MemRegion::accessible() const {
	return readable() || writable() || executable();
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
bool MemRegion::readable() const {
	return
		m_Permissions == PAGE_EXECUTE_READ ||
		m_Permissions == PAGE_EXECUTE_READWRITE ||
		m_Permissions == PAGE_READONLY ||
		m_Permissions == PAGE_READWRITE;
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
bool MemRegion::writable() const {
	return
		m_Permissions == PAGE_EXECUTE_READWRITE ||
		m_Permissions == PAGE_EXECUTE_WRITECOPY ||
		m_Permissions == PAGE_READWRITE ||
		m_Permissions == PAGE_WRITECOPY;
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
bool MemRegion::executable() const	{
	return 
		m_Permissions == PAGE_EXECUTE || 
		m_Permissions == PAGE_EXECUTE_READ ||
		m_Permissions == PAGE_EXECUTE_READWRITE ||
		m_Permissions == PAGE_EXECUTE_WRITECOPY;
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
int MemRegion::size() const {
	return end - start;
}
